unit umain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    // ---
    FullScreen: boolean;
    SavedWindowState: TWindowState;
    SavedLeft: Integer;
    SavedTop: Integer;
    SavedWidth: Integer;
    SavedHeight: Integer;
    SavedBorderStyle: TFormBorderStyle;
    // ---
  public

  end;

var
  Form1: TForm1;


implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  SavedWindowState := WindowState;
  SavedBorderStyle := BorderStyle;
  FullScreen := False;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  FullScreen := not FullScreen;
  if FullScreen then
    begin
      // save window pos
      SavedLeft:= Left;
      SavedTop:= Top;
      SavedWidth:= Width;
      SavedHeight:= Height;
      // switch to fullscreen
      BorderStyle := bsNone;
      WindowState := wsMaximized;
    end
  else
    begin
      // switch back to orignal mode
      BorderStyle := SavedBorderStyle;
      WindowState := SavedWindowState;
      // restore window pos
      Top := SavedTop;
      Left := SavedLeft;
      Width := SavedWidth;
      Height := SavedHeight;
    end;
end;


end.

